
#import <QuartzCore/QuartzCore.h>
#import "GameItemView.h"


@implementation GameItemView


- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
		self.opaque = NO;	//ビューを透明にする
    }
    return self;
}


- (void)drawRect:(CGRect)rect {
	UIImage		*image = [UIImage imageNamed:@"item00.png"];
	[image drawInRect:rect];
}


- (void)dealloc {
    [super dealloc];
}

- (void)setAnimePosition:(CGPoint)toPoint Duration:(CGFloat)dur
{
	//移動のアニメーション
	CABasicAnimation*	anime = [CABasicAnimation animationWithKeyPath:@"position"];
	CGPoint	fromPt = self.layer.position;
	anime.duration = dur;
	anime.fromValue = [NSValue valueWithCGPoint:fromPt];
	anime.toValue = [NSValue valueWithCGPoint:toPoint];		
	anime.delegate = self;
	[self.layer addAnimation:anime forKey:@"animatePosition"];
	CGRect			aFrame = [self frame];
	CGPoint			nowPt = toPoint;
	[self.layer setFrame:CGRectMake(nowPt.x-(aFrame.size.width/2), nowPt.y-(aFrame.size.height/2), aFrame.size.width, aFrame.size.height)];

	//矩形サイズのアニメーション
	float	scl1 = 1.0;
	float	scl2 = 2.0;
	anime = [CABasicAnimation animationWithKeyPath:@"bounds"];
	CGRect	fromRect = CGRectMake(self.layer.bounds.origin.x, self.layer.bounds.origin.y, self.layer.bounds.size.width*scl1, self.layer.bounds.size.height*scl1);
	CGRect	toRect   = CGRectMake(self.layer.bounds.origin.x, self.layer.bounds.origin.y, self.layer.bounds.size.width*scl2, self.layer.bounds.size.height*scl2);
	anime.fromValue = [NSValue valueWithCGRect:fromRect];
	anime.toValue = [NSValue valueWithCGRect:toRect];		
	anime.duration = dur;
	anime.delegate = self;
	[self.layer addAnimation:anime forKey:@"animateBounds"];
	self.layer.bounds = toRect;
	
	//透明度のアニメーション
	anime = [CABasicAnimation animationWithKeyPath:@"opacity"];
	anime.fromValue = [NSNumber numberWithFloat:1.0];
	anime.toValue = [NSNumber numberWithFloat:0.0];
	anime.delegate = self;
	anime.duration = dur;
	[self.layer addAnimation:anime forKey:@"animateOpacity"];
	self.layer.opacity = 0.0;
}


- (void)animationDidStop:(CAAnimation *)theAnimation finished:(BOOL)flag
{
	[self removeFromSuperview];
}

@end
